#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
##############################################################################
#                                                                            #
# Main.tk: Contains a series of procedures for building the main application #
#          window.                                                           # 
#                                                                            # 
##############################################################################

proc build_main_window {mainWindow} {
  global sysinfo
  
  frame $mainWindow.menubar -class Plain
  frame $mainWindow.main -class Plain
  set sysinfo(main_frame) $mainWindow.main
  frame $mainWindow.statusbar -class Plain

# pack the rest of the frames: hosts, queues, and jobs.
  pack $mainWindow.menubar $mainWindow.main $mainWindow.statusbar -pady 1 \
					    -side top -expand 1 -fill both

  set sysinfo(statusbar_frame) $mainWindow.statusbar
  fillMenubarFrame $mainWindow.menubar
  fillStatusbarFrame $mainWindow.statusbar
  fillMainFrame $mainWindow.main

}

proc fillMainFrame widget_name {
  global sysinfo sysnodes

  displayView $widget_name $sysinfo(systemName) 1
}

proc fillStatusbarFrame widget_name {
  global sysinfo canvas

  frame $widget_name.header    -borderwidth 2 -height 10m -relief raised
  frame  $widget_name.list     -borderwidth 3


  label $widget_name.header.label -anchor nw \
	-text "INFO:" -padx 1 -pady 1
  pack $widget_name.header.label -fill both -expand true
  set sysinfo(infoBox) [lindex [buildFullListbox $widget_name.list \
           $sysinfo(infoListBoxWidth)x$sysinfo(infoListBoxHeight) "" xyscroll] 3]
  pack $widget_name.header $widget_name.list -side left -fill both -expand 1 -padx 0 -pady 0
}

proc displayView {frame sitename {init 0}} {
	global sysinfo sysview

	if {[string compare $sitename ""] == 0} {
		return
	}

#	if { !$init && [info exists sysinfo(systemName)] && \
#		 [string compare $sysinfo(systemName) $sitename] == 0} {
#		return
#	}

	systemDelete $sysinfo(systemFrame)

	set sysinfo(systemFrame) $frame.c_$sitename
	set sysinfo(systemName) $sitename

	if { [string compare $sysview($sitename) ICON] == 0 } {
		iconView 1
	} elseif { [string compare $sysview($sitename) FULL] == 0 } {
		fullView 1
	} else {
		InfoBox_sendmsg "displayView: view type: $sysview($sitename) unknown!" 1
	}

}

###############################################################################
###	MENU BAR Frame procedures					      #

###############################################################################
###	MENU BAR Frame procedures					      #
###############################################################################
proc fillMenubarFrame {widget_name} {

  global sysinfo canvas bitmap_dir tk_version dialog

  frame $widget_name.menu -class Plain
  frame $widget_name.buttons -class Plain
  
  menubutton $widget_name.menu.sys -menu $widget_name.menu.sys.m \
		-anchor w -text "Site.." -borderwidth 2 -relief raised

  set sysinfo(sysMenuButton) $widget_name.menu.sys.m
  menu $sysinfo(sysMenuButton) -borderwidth 2 -relief raised

  foreach sitename [siteNamesGet] {
	$sysinfo(sysMenuButton) add radio -label $sitename \
		-variable sysinfo(systemName) \
		-value $sitename \
		-command "displayView $sysinfo(main_frame) $sitename"
  }


  if {$tk_version >= 4.0} {
        $sysinfo(sysMenuButton) configure -tearoff 0
  }

#  pack $widget_name.menu.sys -side left -anchor nw -expand 1 -fill both
  pack $widget_name.menu.sys -side left -anchor nw -expand 1 -fill both
  pack $widget_name.menu $widget_name.buttons -side left
  set cmdButtons [buildCmdButtons $widget_name.buttons \
                  { {  {prefer "Pref.."} } \
		    { {update_auto "AutoUpdate.."} } \
		    { {help "Help"} \
		      {about "About.."} } \
		    {  {close "Close"}  }
		    { {iconify ""} \
		      {maximize ""} } } x 1 10 1 0 0 20]
  
  set cmdButtonFrame   [lindex $cmdButtons 0]
  set cmdButtonPref    [lindex $cmdButtons 1]
  set cmdButtonUpdAuto [lindex $cmdButtons 2]
  set cmdButtonHelp    [lindex $cmdButtons 3]
  set cmdButtonAbout   [lindex $cmdButtons 4]
  set cmdButtonClose   [lindex $cmdButtons 5]
  set cmdButtonIconify [lindex $cmdButtons 6]
  set cmdButtonMaximize [lindex $cmdButtons 7]


  $cmdButtonPref configure -width 10  -command {pref $dialog(mainWindow) $dialog(mainWindow)}
  $cmdButtonUpdAuto configure -width 14  -command {auto_upd}
  set sysinfo(cmdButtonUpdAuto) $cmdButtonUpdAuto

  $cmdButtonIconify configure -bitmap @$bitmap_dir/iconize.bmp -padx 1 -pady 1 \
	-anchor c -width 14 -height $canvas(bigLabelFontHeight) \
	-command {iconView}

  $cmdButtonMaximize configure -bitmap @$bitmap_dir/maximize.bmp -padx 1 \
	-pady 1 -anchor c -width 14 -height $canvas(bigLabelFontHeight) \
	-command {fullView} 

  $cmdButtonHelp    configure -command { xpbs_help main ""}
  $cmdButtonAbout   configure -command { about }
  $cmdButtonClose configure -command {
	prefSaveSitesInfo
	if [prefDoIt] {
		prefsave
	}
	exit
  }
}

proc iconView {{force 0}} {
        global canvas sysinfo sysview

        if {[string compare $sysinfo(systemFrame) ""] == 0 || \
            [string compare $sysinfo(systemName) ""] == 0} {
                return
        }
        if {!$force && \
                [string compare $sysview($sysinfo(systemName)) ICON] == 0} {
                return
        }
        set sysview($sysinfo(systemName)) ICON

        if [winfo exists $sysinfo(systemFrame)] {
        	systemNodesReCreate $sysinfo(systemFrame)
        } else {
        	systemNodesCreate $sysinfo(systemFrame) $sysinfo(systemName)
                after 1000 systemPopulateNodesWithInfo $sysinfo(systemFrame) 1
        }
}

proc fullView {{force 0}} {
        global canvas sysinfo sysview

        if {[string compare $sysinfo(systemFrame) ""] == 0 || \
            [string compare $sysinfo(systemName) ""] == 0} {
                return
        }

        if {!$force && \
                [string compare $sysview($sysinfo(systemName)) FULL] == 0} {
                return
        }

        set sysview($sysinfo(systemName)) FULL

        if [winfo exists $sysinfo(systemFrame)] {
        	systemNodesReCreate $sysinfo(systemFrame)
        } else {
        	systemNodesCreate $sysinfo(systemFrame) $sysinfo(systemName)
                after 1000 systemPopulateNodesWithInfo $sysinfo(systemFrame) 1
        }
}
